#!/usr/bin/env ruby

require "sp_ext"

map=[
'###########',
'# #  4   @#',
'#2#~##    #',
'##~####   #',
'#3#   ##  #',
'# # # @   #',
'#   #######',
'# 1     0 #',
'###########'
]


def find(m,a)
  i = 0
  x = nil
  y = 0
  for s in m
    break if (x = s.index(a))
    y+=1;
  end
  [x,y]
end

def conv(m)
  s1 = "~@ #0-9"
  s2 = "     "
  s2[0],s2[1],s2[2],s2[3] = 254,0,1,255,1
  m.map { |s| s.tr(s1,s2) }
end

puts map[1][9]
cm = conv(map)
puts "hmm: #{cm[1][9]}"
$w = map[0].size
sp = PathSearch.new($w,map.size,conv(map));

sp.block_unreachable(4*$w+1)
map3 = map.map{ |s| s.tr("0-9"," ") }
sp.base_update
size = $w*map.size
bc = {}
bcc = "a"
size.times do |pos|
  x = sp.base_dir(pos);
  if x > 0 
    map3[pos/$w][pos%$w] = "0123456789abcdef"[x]
  end
  if sp[pos] >= 254
    map3[pos/$w][pos%$w] = "~#"[sp[pos]-254]
  end
end
puts map3
